import os
import re
import utaupy

#パスの末尾フォルダをinputからoutputに変える
def reverse(reverse_path):
    # パスを分解する
    dir_path, file_name = os.path.split(reverse_path)
    # 最後のディレクトリ名を取得
    parent_dir, last_dir = os.path.split(dir_path)
    
    # 最後のディレクトリ名が "input" であれば "output" に変更
    if last_dir == "input":
        new_dir_path = os.path.join(parent_dir, "output")
        reverse_path = os.path.join(new_dir_path, file_name)
        #print(new_dir_path)
        #print('パス変更した')
        return reverse_path
    else:
        #print('パス変更なし')
        return reverse_path  # 変更なしの場合は元のパスを返す

#母音判定　どうせ無声母音こないでしょ
def vowel_judge(vowel_judge_var):
    if vowel_judge_var in ['a', 'i', 'u', 'e', 'o', 'N']:
        vowel_judge_truth = 'v'
    else:
        vowel_judge_truth = 'c'
    return vowel_judge_truth

#ガバ子音判定　synthvのドットノートに来そうな子音以外のやつ
def consonant_judge(consonant_judge_var):
    if consonant_judge_var not in ['a', 'i', 'u', 'e', 'o', '.cl', 'cl', 'N']:
        consonant_judge_truth = 1
    return consonant_judge_truth
'''
# vをかなに変える
def v_ph2kana(vowel_kana):
    vowel_kana_dict = {'a': 'あ', 'i': 'い', 'u': 'う', 'e': 'え', 'o': 'お', 'N': 'ん'}
    vowel_kana = vowel_kana_dict.get(vowel_kana, vowel_kana)
    return vowel_kana
'''
# 新ノートを作り、母音を持たない c を120tickのカタカナに
def newnote_cvnl(c,v, last_notenum, length):# cvnl -> c v notenum length
    new_note = utaupy.ust.Note()
    new_note.length = length
    new_note.notenum = last_notenum
    new_note.preutterance = ''
    new_note.lyric = cv2kana(c, v)
    #print(f"{c}/{v}/{new_note.lyric}")
    return new_note

def svust_fix(ust_path):


    #ust_path = input('UST path: ')




    ust_path_noquat = ust_path.strip('"')
    #print (ust_path_noquat)

    ust = utaupy.ust.load(ust_path_noquat)
    ust.make_final_note_R()
    notes = ust.notes


    #length をばらす

    #print(notes)
    #print('-------------------------------------------------')
    rounded_length = []
    for i in notes:
        rounded_length.append(round(float(i['Length'])))


    for i,note in enumerate(notes):
        note.length = rounded_length[i]
    


    # glottalstop  ' を・に変換
    for note in notes:
        if note.lyric.startswith("'"):
            note.lyric = '・' + note.lyric[1:]

    #小数点の付いたlengthを四捨五入
    #rounded_lengths = [round(float(note.length)) for note in notes]
    #float_lengths = [round(note.length) for note in notes]

    #rounded_lengths = [int(round(float(note.length))) for note in notes]
    #　-を処理するために直前の母音を探す
    with open('phoneme.txt') as f:
        phonemes_raw = f.read()
    phonemes = phonemes_raw.splitlines()
    phonemes = [i.split() for i in phonemes]


    ##############  . - cl　の処理　######################
    temp = ''
    for i, note in enumerate(notes):
        # -　の場合
        #print(f"###{note.lyric}")
        if note.lyric == "-":
            for phoneme in phonemes:
                if notes[i-1].lyric == phoneme[0]:# 1個前のノートが音素リストの1個目、かなと一致したとき
                    if len(phoneme) == 2:# 母音の時
                        note.lyric = phoneme[1]
                    else:
                        note.lyric = phoneme[2]
                    #if note.lyric == "a":
                    note.lyric = "あ" if note.lyric == "a" else note.lyric
                    note.lyric = "い" if note.lyric == "i" else note.lyric
                    note.lyric = "う" if note.lyric == "u" else note.lyric
                    note.lyric = "え" if note.lyric == "e" else note.lyric
                    note.lyric = "お" if note.lyric == "o" else note.lyric
                    note.lyric = "ん" if note.lyric == "N" else note.lyric
                    note.lyric = "R" if note.lyric == "pau" else note.lyric
        # . で始まる場合
        if note.lyric.startswith('.'):
            temp = re.sub(r'^.', '', note.lyric)
            temp = temp.split(' ')
            # clで終わる場合
            if note.lyric.endswith('cl'):
                if len(temp) == 2:# . * cl
                    note.lyric = cv2kana('',temp[0]) + 'っ'
                elif len(temp) == 3:# . * * cl
                    note.lyric = cv2kana(temp[0], temp[1]) + 'っ'
                elif len(temp) == 4:# . * * * cl
                    # c v c clの場合
                    if vowel_judge(temp[0]) == 'c' and  vowel_judge(temp[1]) == 'v' and vowel_judge(temp[2]) == 'c':
                        note.lyric = cv2kana(temp[0], temp[1])
                        note.length -= 120
                        ust.notes.insert(i+1, newnote_cvnl(temp[2], '', note.notenum, 120))

            # .clで始まる場合
            elif note.lyric.startswith('.cl'):
                temp = note.lyric.split(' ')
                # .cl v
                if len(temp) == 2:
                    if  vowel_judge(temp[1]) == 'v':
                        note.lyric = 'っ'
                        temp_length = note.length
                        note.length = note.length //2
                        new_length = temp_length - note.length
                        ust.notes.insert(i+1, newnote_cvnl('', temp[1],note.notenum,new_length)) 
                        
                # .cl * *
                elif len(temp) == 3:
                    # .cl c v
                    if vowel_judge(temp[1]) == 'c' and vowel_judge(temp[2]) == 'v': 
                        note.lyric = 'っ'
                        temp_length = note.length
                        note.length = note.length //2
                        new_length = temp_length - note.length
                        ust.notes.insert(i+1, newnote_cvnl(temp[1], temp[2],note.notenum,new_length)) 
                
                    # .cl v c
                    if vowel_judge(temp[1]) == 'v' and vowel_judge(temp[2]) == 'c': 
                        note.lyric = cv2kana('GlottalStop', temp[1])
                        note.length -= 120
                        ust.notes.insert(i+1, newnote_cvnl(temp[2], '',note.notenum,120)) 


            # その他
            else:
                # * * * 3音素
                if len(temp) == 3:
                    # 母音で終わらない場合　 c v c 決め打ち
                    if vowel_judge(temp[0]) == 'c' and  vowel_judge(temp[1]) == 'v' and vowel_judge(temp[2]) == 'c':
                        note.lyric = cv2kana(temp[0], temp[1])
                        note.length -= 120
                        ust.notes.insert(i+1, newnote_cvnl(temp[2],'', note.notenum,120))
                        
                    if vowel_judge(temp[0]) == 'c' and  vowel_judge(temp[1]) == 'c' and vowel_judge(temp[2]) == 'v':
                        note.lyric = cv2kana(temp[0], '')
                        new_length = note.length -120
                        note.length = 120
                        
                        new_note = utaupy.ust.Note()
                        new_note.length = new_length
                        new_note.notenum = note.notenum
                        new_note.preutterance = ''
                        ust.notes.insert(i+1, new_note) 
                        new_note.lyric = cv2kana(temp[1], temp[2])
                
                # * * 2音素
                if len(temp) == 2:
                    # C V
                    if vowel_judge(temp[0]) == 'c' and  vowel_judge(temp[1]) == 'v':
                        note.lyric = cv2kana(temp[0], temp[1])

                    # V C
                    if vowel_judge(temp[0]) == 'v' and  vowel_judge(temp[1]) == 'c':
                        note.lyric = cv2kana(temp[1], temp[2])
                        temp_length = note.length
                        note.length = temp_length - 120

                        new_note = utaupy.ust.Note()
                        new_note.length = 120
                        new_note.notenum = note.notenum
                        new_note.preutterance = ''
                        new_note.lyric = cv2kana(new_note.lyric, '')
                        ust.notes.insert(i+1, new_note) 
                    


    #print (notes)
    
    #clの次の母音を・に
    for i, note in enumerate(notes):
        if i == 0:
            continue
        # 1個前のノートの末尾が　っ　で、　今のノートが母音の場合、今のノートに・を付ける
        elif notes[i-1].lyric.endswith('っ') and vowel_judge(v_vowel(note.lyric)) == 'v':
            note.lyric = cv2kana('GlottalStop',v_vowel(note.lyric))
            
    

    ###################### 休符まとめ #############################
    new_notes = []
    i = 0
    while i < len(notes):
        if i == len(notes)-1:
            i += 1
            continue
        elif notes[i].lyric == 'R' and notes[i+1].lyric == 'R':
            notes[i].length = notes[i+1].length + notes[i].length
            #print(notes[i+1])
            del notes[i+1]
        elif c_vowel(notes[i].lyric) == v_vowel(notes[i+1].lyric) and notes[i].notenum == notes[i+1].notenum:
            notes[i].length = notes[i+1].length + notes[i].length
            #print(notes[i+1])
            del notes[i+1]            
        else:
            new_notes.append(notes[i])
            i += 1
    notes = new_notes



    ################ SAVE ##############################

    reverse_path = reverse(ust_path_noquat)
    
    ust.write(reverse_path)
    #print(ust_path_noquat)
    print(f"出力: {reverse_path}")

    #print(ust)






if __name__ == "__main__":
    ust_path = input('UST path: ')
    svust_fix(ust_path)



    


##############  子音単品をカナ化 #################
'''
def unvoice_kana(c):
    c = 'トゥ' if c == 't' else c
    c = 'ドゥ' if c == 'd' else c
    c = 'ス' if c == 's' else c
    c = 'ズ' if c == 'z' else c
    c = 'シ' if c == 'sh' else c
    c = 'チ' if c == 'ch' else c
    c = 'プ' if c == 'p' else c
    c = 'ブ' if c == 'b' else c
    c = 'フ' if c == 'f' else c
    c = 'ヒ' if c == 'h' else c
    c = 'ル' if c == 'r' else c
    c = 'ク' if c == 'k' else c
    c = 'グ' if c == 'g' else c
    c = 'ヴ' if c == 'v' else c
    c = 'ん' if c == 'm' else c
    c = 'ん' if c == 'n' else c
    c = 'ツ' if c == 'ts' else c
    return c
'''
########### c+v をカナ化
def cv2kana(c, v):# ない時は''
    if c != '' and v == '':
        dict_unvoice = {'t': 'トゥ','d': 'ドゥ','s': 'ス','z': 'ズ','sh': 'シ','ch': 'チ','p': 'プ','b': 'ブ','f': 'フ','h': 'ヒ','r': 'ル','k': 'ク','g': 'グ','v': 'ヴ','n': 'ん','m': 'ん','ts': 'ツ'}
        cv = dict_unvoice.get(c, c)
    else:
        cv = c + v
        dict_kana = {'cl': 'っ', 'GlottalStopa': '・あ', 'GlottalStopA': '・ア', 'GlottalStopi': '・い', 'GlottalStopI': '・イ', 'GlottalStopu': '・う', 'GlottalStopU': '・ウ', 'GlottalStope': '・え', 'GlottalStopE': '・エ', 'GlottalStopo': '・お', 'GlottalStopO': '・オ', 'GlottalStopN': '・ん', 'Edgea': '’あ', 'EdgeA': '’ア', 'Edgei': '’い', 'EdgeI': '’イ', 'Edgeu': '’う', 'EdgeU': '’ウ', 'Edgee': '’え', 'EdgeE': '’エ', 'Edgeo': '’お', 'EdgeO': '’オ', 'EdgeN': '’ん', 'wu': 'うぅ', 'fyu': 'ふゅ', 'a': 'あ', 'i': 'い', 'u': 'う', 'e': 'え', 'o': 'お', 'N': 'ん', 'pau': 'R', 'ka': 'か', 'ki': 'き', 'ku': 'く', 'ke': 'け', 'ko': 'こ', 'kA': 'カ', 'kI': 'キ', 'kU': 'ク', 'kE': 'ケ', 'kO': 'コ', 'sa': 'さ', 'shi': 'し', 'su': 'す', 'se': 'せ', 'so': 'そ', 'sA': 'サ', 'shI': 'シ', 'sU': 'ス', 'sE': 'セ', 'sO': 'ソ', 'ta': 'た', 'chi': 'ち', 'tsu': 'つ', 'te': 'て', 'to': 'と', 'tA': 'タ', 'chI': 'チ', 'tsU': 'ツ', 'tE': 'テ', 'tO': 'ト', 'na': 'な', 'ni': 'に', 'nu': 'ぬ', 'ne': 'ね', 'no': 'の', 'nA': 'ナ', 'nI': 'ニ', 'nU': 'ヌ', 'nE': 'ネ', 'nO': 'ノ', 'ha': 'は', 'hi': 'ひ', 'fu': 'ふ', 'he': 'へ', 'ho': 'ほ', 'hA': 'ハ', 'hI': 'ヒ', 'fU': 'フ', 'hE': 'ヘ', 'hO': 'ホ', 'ma': 'ま', 'mi': 'み', 'mu': 'む', 'me': 'め', 'mo': 'も', 'mA': 'マ', 'mI': 'ミ', 'mU': 'ム', 'mE': 'メ', 'mO': 'モ', 'ya': 'や', 'yu': 'ゆ', 'ye': 'いぇ', 'yo': 'よ', 'yA': 'ヤ', 'yU': 'ユ', 'yE': 'イェ', 'yO': 'ヨ', 'ra': 'ら', 'ri': 'り', 'ru': 'る', 're': 'れ', 'ro': 'ろ', 'rA': 'ラ', 'rI': 'リ', 'rU': 'ル', 'rE': 'レ', 'rO': 'ロ', 'wa': 'わ', 'wA': 'ワ', 'ga': 'が', 'gi': 'ぎ', 'gu': 'ぐ', 'ge': 'げ', 'go': 'ご', 'gA': 'ガ', 'gI': 'ギ', 'gU': 'グ', 'gE': 'ゲ', 'gO': 'ゴ', 'za': 'ざ', 'ji': 'じ', 'zu': 'ず', 'ze': 'ぜ', 'zo': 'ぞ', 'zA': 'ザ', 'jI': 'ジ', 'zU': 'ズ', 'zE': 'ゼ', 'zO': 'ゾ', 'da': 'だ', 'de': 'で', 'do': 'ど', 'dA': 'ダ', 'dE': 'デ', 'dO': 'ド', 'ba': 'ば', 'bi': 'び', 'bu': 'ぶ', 'be': 'べ', 'bo': 'ぼ', 'bA': 'バ', 'bI': 'ビ', 'bU': 'ブ', 'bE': 'ベ', 'bO': 'ボ', 'pa': 'ぱ', 'pi': 'ぴ', 'pu': 'ぷ', 'pe': 'ぺ', 'po': 'ぽ', 'pA': 'パ', 'pI': 'ピ', 'pU': 'プ', 'pE': 'ペ', 'pO': 'ポ', 'kya': 'きゃ', 'kyu': 'きゅ', 'kye': 'きぇ', 'kyo': 'きょ', 'kyA': 'キャ', 'kyU': 'キュ', 'kyE': 'キェ', 'kyO': 'キョ', 'sha': 'しゃ', 'si': 'すぃ', 'shu': 'しゅ', 'she': 'しぇ', 'sho': 'しょ', 'shA': 'シャ', 'sI': 'スィ', 'shU': 'シュ', 'shE': 'シェ', 'shO': 'ショ', 'cha': 'ちゃ', 'chu': 'ちゅ', 'che': 'ちぇ', 'cho': 'ちょ', 'chA': 'チャ', 'chU': 'チュ', 'chE': 'チェ', 'chO': 'チョ', 'tya': 'てゃ', 'ti': 'てぃ', 'tyu': 'てゅ', 'tyo': 'てょ', 'tyA': 'テャ', 'tI': 'ティ', 'tyU': 'テュ', 'tyO': 'テョ', 'nya': 'にゃ', 'nyu': 'にゅ', 'nye': 'にぇ', 'nyo': 'にょ', 'nyA': 'ニャ', 'nyU': 'ニュ', 'nyE': 'ニェ', 'nyO': 'ニョ', 'hya': 'ひゃ', 'hyu': 'ひゅ', 'hye': 'ひぇ', 'hyo': 'ひょ', 'hyA': 'ヒャ', 'hyU': 'ヒュ', 'hyE': 'ヒェ', 'hyO': 'ヒョ', 'mya': 'みゃ', 'myu': 'みゅ', 'mye': 'みぇ', 'myo': 'みょ', 'myA': 'ミャ', 'myU': 'ミュ', 'myE': 'ミェ', 'myO': 'ミョ', 'rya': 'りゃ', 'ryu': 'りゅ', 'rye': 'りぇ', 'ryo': 'りょ', 'ryA': 'リャ', 'ryU': 'リュ', 'ryE': 'リェ', 'ryO': 'リョ', 'gya': 'ぎゃ', 'gyu': 'ぎゅ', 'gye': 'ぎぇ', 'gyo': 'ぎょ', 'gyA': 'ギャ', 'gyU': 'ギュ', 'gyE': 'ギェ', 'gyO': 'ギョ', 'ja': 'じゃ', 'ju': 'じゅ', 'je': 'じぇ', 'jo': 'じょ', 'jA': 'ジャ', 'jU': 'ジュ', 'jE': 'ジェ', 'jO': 'ジョ', 'bya': 'びゃ', 'byu': 'びゅ', 'bye': 'びぇ', 'byo': 'びょ', 'byA': 'ビャ', 'byU': 'ビュ', 'byE': 'ビェ', 'byO': 'ビョ', 'pya': 'ぴゃ', 'pyu': 'ぴゅ', 'pye': 'ぴぇ', 'pyo': 'ぴょ', 'pyA': 'ピャ', 'pyE': 'ピェ', 'pyO': 'ピョ', 'dya': 'でゃ', 'di': 'でぃ', 'dyu': 'でゅ', 'dye': 'でぇ', 'dyo': 'でょ', 'dyA': 'デャ', 'dI': 'ディ', 'dyU': 'デュ', 'dyE': 'デェ', 'dyO': 'デョ', 'wi': 'うぃ', 'we': 'うぇ', 'wo': 'うぉ', 'wI': 'ウィ', 'wE': 'ウェ', 'wO': 'ウォ', 'tsa': 'つぁ', 'tsi': 'つぃ', 'tse': 'つぇ', 'tso': 'つぉ', 'tsA': 'ツァ', 'tsI': ' ツィ', 'tsE': 'ツェ', 'tsO': 'ツォ', 'tu': 'とぅ', 'tU': 'トゥ', 'fa': 'ふぁ', 'fi': 'ふぃ', 'fe': 'ふぇ', 'fo': 'ふぉ', 'fA': 'ファ', 'fI': 'フィ', 'fE': 'フェ', 'fO': 'フォ', 'zi': 'ずぃ', 'zI': 'ズィ', 'du': 'どぅ', 'dU': 'ドゥ', 'va': 'ヴぁ', 'vi': 'ヴぃ', 'vu': 'ヴ', 've': 'ヴぇ', 'vo': 'ヴぉ', 'vA': 'ヴァ', 'vI': 'ヴィ', 'vE': 'ヴェ', 'vO': 'ヴォ'}
        cv = dict_kana.get(cv, cv)
    return cv

############### かな文字の母音判定
def c_vowel(a):
    c_dict = {'っ': 'cl', '・あ': 'a', '・ア': 'A', '・い': 'i', '・イ': 'I', '・う': 'u', '・ウ': 'U', '・え': 'e', '・エ': 'E', '・ お': 'o', '・オ': 'O', '・ん': 'N', '’あ': 'a', '’ア': 'A', '’い': 'i', '’イ': 'I', '’う': 'u', '’ウ': 'U', '’え': 'e', '’エ': 'E', '’お': 'o', '’オ': 'O', '’ん': 'N', 'うぅ': 'u', 'ふゅ': 'u', 'あ': 'a', 'い': 'i', 'う': 'u', 'え': 'e', ' お': 'o', 'ん': 'N', 'R': 'pau', 'か': 'a', 'き': 'i', 'く': 'u', 'け': 'e', 'こ': 'o', 'カ': 'A', 'キ': 'I', 'ク': 'U', 'ケ': 'E', 'コ': 'O', 'さ': 'a', 'し': 'i', 'す': 'u', 'せ': 'e', 'そ': 'o', 'サ': 'A', 'シ': 'I', 'ス': 'U', 'セ': 'E', 'ソ': 'O', 'た': 'a', 'ち': 'i', 'つ': 'u', 'て': 'e', 'と': 'o', 'タ': 'A', 'チ': 'I', 'ツ': 'U', 'テ': 'E', 'ト': 'O', 'な': 'a', 'に': 'i', 'ぬ': 'u', 'ね': 'e', 'の': 'o', 'ナ': 'A', 'ニ': 'I', 'ヌ': 'U', 'ネ': 'E', 'ノ': 'O', 'は': 'a', 'ひ': 'i', 'ふ': 'u', 'へ': 'e', 'ほ': 'o', 'ハ': 'A', 'ヒ': 'I', 'フ': 'U', 'ヘ': 'E', 'ホ': 'O', 'ま': 'a', 'み': 'i', 'む': 'u', 'め': 'e', 'も': 'o', 'マ': 'A', 'ミ': 'I', 'ム': 'U', 'メ': 'E', 'モ': 'O', 'や': 'a', 'ゆ': 'u', 'いぇ': 'e', 'よ': 'o', 'ヤ': 'A', 'ユ': 'U', 'イェ': 'E', 'ヨ': 'O', 'ら': 'a', 'り': 'i', 'る': 'u', 'れ': 'e', 'ろ': 'o', 'ラ': 'A', 'リ': 'I', 'ル': 'U', 'レ': 'E', 'ロ': 'O', 'わ': 'a', 'ワ': 'A', 'が': 'a', 'ぎ': 'i', 'ぐ': 'u', 'げ': 'e', 'ご': 'o', 'ガ': 'A', 'ギ': 'I', 'グ': 'U', 'ゲ': 'E', 'ゴ': 'O', 'ざ': 'a', 'じ': 'i', 'ず': 'u', 'ぜ': 'e', 'ぞ': 'o', 'ザ': 'A', 'ジ': 'I', 'ズ': 'U', 'ゼ': 'E', 'ゾ': 'O', 'だ': 'a', 'で': 'e', 'ど': 'o', 'ダ': 'A', 'デ': 'E', 'ド': 'O', 'ば': 'a', 'び': 'i', 'ぶ': 'u', 'べ': 'e', 'ぼ': 'o', 'バ': 'A', 'ビ': 'I', 'ブ': 'U', 'ベ': 'E', 'ボ': 'O', 'ぱ': 'a', 'ぴ': 'i', 'ぷ': 'u', 'ぺ': 'e', 'ぽ': 'o', 'パ': 'A', 'ピ': 'I', 'プ': 'U', 'ペ': 'E', 'ポ': 'O', 'きゃ': 'a', 'き ゅ': 'u', 'きぇ': 'e', 'きょ': 'o', 'キャ': 'A', 'キュ': 'U', 'キェ': 'E', 'キョ': 'O', 'しゃ': 'a', 'すぃ': 'i', 'しゅ': 'u', 'しぇ': 'e', 'しょ': 'o', 'シャ': 'A', 'スィ': 'I', 'シュ': 'U', 'シェ': 'E', 'ショ': 'O', 'ちゃ': 'a', 'ちゅ': 'u', 'ちぇ': 'e', 'ちょ': 'o', 'チャ': 'A', 'チュ': 'U', 'チェ': 'E', 'チョ': 'O', 'てゃ': 'a', 'てぃ': 'i', 'てゅ': 'u', 'てょ': 'o', 'テャ': 'A', 'ティ': 'I', 'テュ': 'U', 'テョ': 'O', 'にゃ': 'a', 'にゅ': 'u', 'にぇ': 'e', 'にょ': 'o', ' ニャ': 'A', 'ニュ': 'U', 'ニェ': 'E', 'ニョ': 'O', 'ひゃ': 'a', 'ひゅ': 'u', 'ひぇ': 'e', 'ひょ': 'o', 'ヒャ': 'A', 'ヒ ュ': 'U', 'ヒェ': 'E', 'ヒョ': 'O', 'みゃ': 'a', 'みゅ': 'u', 'みぇ': 'e', 'みょ': 'o', 'ミャ': 'A', 'ミュ': 'U', 'ミェ': 'E', 'ミョ': 'O', 'りゃ': 'a', 'りゅ': 'u', 'りぇ': 'e', 'りょ': 'o', 'リャ': 'A', 'リュ': 'U', 'リェ': 'E', 'リョ': 'O', 'ぎゃ': 'a', 'ぎゅ': 'u', 'ぎぇ': 'e', 'ぎょ': 'o', 'ギャ': 'A', 'ギュ': 'U', 'ギェ': 'E', 'ギョ': 'O', 'じゃ': 'a', 'じゅ': 'u', 'じぇ': 'e', 'じょ': 'o', 'ジャ': 'A', 'ジュ': 'U', 'ジェ': 'E', 'ジョ': 'O', 'びゃ': 'a', 'びゅ': 'u', ' びぇ': 'e', 'びょ': 'o', 'ビャ': 'A', 'ビュ': 'U', 'ビェ': 'E', 'ビョ': 'O', 'ぴゃ': 'a', 'ぴゅ': 'u', 'ぴぇ': 'e', 'ぴ ょ': 'o', 'ピャ': 'A', 'ピェ': 'E', 'ピョ': 'O', 'でゃ': 'a', 'でぃ': 'i', 'でゅ': 'u', 'でぇ': 'e', 'でょ': 'o', 'デャ': 'A', 'ディ': 'I', 'デュ': 'U', 'デェ': 'E', 'デョ': 'O', 'うぃ': 'i', 'うぇ': 'e', 'うぉ': 'o', 'ウィ': 'I', 'ウェ': 'E', 'ウォ': 'O', 'つぁ': 'a', 'つぃ': 'i', 'つぇ': 'e', 'つぉ': 'o', 'ツァ': 'A', 'ツィ': 'I', 'ツェ': 'E', 'ツォ': 'O', 'とぅ': 'u', 'トゥ': 'U', 'ふぁ': 'a', 'ふぃ': 'i', 'ふぇ': 'e', 'ふぉ': 'o', 'ファ': 'A', 'フィ': 'I', 'フェ': 'E', ' フォ': 'O', 'ずぃ': 'i', 'ズィ': 'I', 'どぅ': 'u', 'ドゥ': 'U', 'ヴぁ': 'a', 'ヴぃ': 'i', 'ヴ': 'u', 'ヴぇ': 'e', 'ヴぉ': 'o', 'ヴァ': 'A', 'ヴィ': 'I', 'ヴェ': 'E', 'ヴォ': 'O'}
    a = c_dict.get(a, 'c_none') 
    return a

################# 母音かなのアルファベット化
def v_vowel(a):
    v_dict = {'あ': 'a', 'い': 'i', 'う': 'u', 'え': 'e', ' お': 'o', 'ん': 'N'}
    a = v_dict.get(a, 'v_none') 
    return a